/* @(#)scsi-unixware.c	1.8 99/09/17 Copyright 1998 J. Schilling, Santa Cruz Operation */
#ifndef lint
static	char __sccsid[] =
	"@(#)scsi-unixware.c	1.8 99/09/17 Copyright 1998 J. Schilling, Santa Cruz Operation";
#endif
/*
 *	Interface for the SCO UnixWare SCSI implementation.
 *
 *	Warning: you may change this source, but if you do that
 *	you need to change the _scg_version and _scg_auth* string below.
 *	You may not return "schily" for an SCG_AUTHOR request anymore.
 *	Choose your name instead of "schily" and make clear that the version
 *	string is related to a modified source.
 *
 *	Copyright (c) 1998 J. Schilling, Santa Cruz Operation
 */
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#undef	sense
#undef	SC_PARITY
#undef	scb

#include <sys/sysmacros.h>
#include <sys/scsi.h>
#include <sys/sdi_edt.h>
#include <sys/sdi.h>

/*
 *	Warning: you may change this source, but if you do that
 *	you need to change the _scg_version and _scg_auth* string below.
 *	You may not return "schily" for an SCG_AUTHOR request anymore.
 *	Choose your name instead of "schily" and make clear that the version
 *	string is related to a modified source.
 */
LOCAL	char	_scg_trans_version[] = "scsi-unixware.c-1.8";	/* The version for this transport*/
/* Max. number of scg scsibusses.  The real limit would be           */
/* MAX_HBA * MAX_BUS (which would be 32 * 8 on UnixWare 2.1/7.x),    */
/* but given that we will hardly see such a beast, lets take 32      */

#define	MAX_SCG		32		

	/* maximum defines for UnixWare 2.x/7.x from <sys/sdi_edt.h> */

#define	MAX_TGT		MAX_EXTCS	/* Max # of target id's      */
#define	MAX_LUN		MAX_EXLUS	/* Max # of lun's            */

#define	MAX_DMA		(32*1024)	

#define MAXLINE	80

#define DEV_DIR		"/tmp"
#define	DEV_NAME	"scg.s%1dt%1dl%1d"


typedef struct scg2sdi {
	int	valid;
	int	open;
	int	atapi;
	int	initiator;
	int	hba;
	int	bus;
	int	tgt;
	int	lun;

	int	fd;
	dev_t	node;
	dev_t	major;
	dev_t	minor;
	char	type[20];
	char	vend[40];
	char	devn[32];

} scg2sdi_t;
	
LOCAL	scg2sdi_t	sdidevs [MAX_SCG][MAX_TGT][MAX_LUN];

struct scg_local {
	short	scgfiles[MAX_SCG][MAX_TGT][MAX_LUN];
};
#define scglocal(p)	((struct scg_local *)((p)->local)) 

/* -------------------------------------------------------------------------
** SCO UnixWare 2.1.x / UnixWare 7 provide a scsi pass-through mechanism, 
** which can be used to access any configured scsi device. 
**
** NOTE: The libscg UnixWare passthrough routines have changed!
**
** The new routines allow the usage of scsibus, target id and lun, so we 
** are really compatible with the rest of the world.
** 
** For compatibility with older releases and to avoid confusion for existing 
** installation the old style is still valid but we would like everybody to 
** use the new style. The -scanbus option does now work and tells you what 
** "dev=..." string to use.
*/

/*
 * Return version information for the low level SCSI transport code.
 * This has been introduced to make it easier to trace down problems
 * in applications.
 */
EXPORT char *
scg__version(scgp, what)
	SCSI	*scgp;
	int	what;
{
	if (scgp != (SCSI *)0) {
		switch (what) {

		case SCG_VERSION:
			return (_scg_trans_version);
		/*
		 * If you changed this source, you are not allowed to
		 * return "schily" for the SCG_AUTHOR request.
		 */
		case SCG_AUTHOR:
			return (_scg_auth_schily);
		case SCG_SCCS_ID:
			return (__sccsid);
		}
	}
	return ((char *)0);
}


/*
 * This routine is introduced to create all device node necessary
 * to access any found scsi device. It parses the output of
 * /etc/pdiconfig -l and creates passthru device node for each
 * found scsi device apart from the listed hba's.
 *
 */
LOCAL int 
unixware_init(scgp)
	SCSI	*scgp;

{
	FILE   	       *pdiconfig;
	int   		hba, bus, scg, tgt, lun;
	int   		s, t, l, nscg, nhba, lhba;
	int		atapi, fd, nopen = 0;
	char  		lbus;
	char		line[MAXLINE], class[MAXLINE], ident[MAXLINE];
	char		tmp1[MAXLINE], tmp2[MAXLINE];
	char		devname[256];
	struct stat 	stbuf;
	dev_t		ptdev, major, minor, node;
	
	/* Check for validity of primary hostbus adapter node */
	
	if (stat("/dev/hba/hba1", &stbuf) < 0) {
		return (-1);
	}
	
	if (!S_ISCHR(stbuf.st_mode)) {
		return (-1);
	}

	major = getmajor(stbuf.st_rdev);

	/* read pdiconfig and get all attached scsi devices ! */
	
        if ((pdiconfig = popen("LANG=C /etc/scsi/pdiconfig -l","r")) == NULL) {
                perror("popen(\"LANG=C /etc/scsi/pdiconfig -l\") error\n");
        }

	nscg = -1; nhba = -1; lhba = -1;
	
	memset( tmp1, 0, sizeof(tmp1));
	memset( tmp2, 0, sizeof(tmp2));
	
        for (;;) {
                if (fgets(line, MAXLINE, pdiconfig) == NULL) 
                        break;
			
		lbus = '0';
		
		strncpy(tmp1, line, 1); 

		if ( tmp1[0] != ' ' ) {
			nscg++;
			nhba++;
			hba = atoi(tmp1); 
			lhba = hba;
			atapi = 0;
		}
		else {
			hba = lhba;
		}
		
		strncpy(tmp1, line+2, 1);
		
		if ( tmp1[0] != lbus ) { 
		
			nscg++;
			lbus = tmp1[0];
		}		

		scg = nscg;
		bus = atoi(tmp1);
		
		strncpy( tmp1, line+4, 1);
		tgt = atoi(tmp1);

		strncpy( tmp1, line+6, 1);
		lun = atoi(tmp1);
				
		memset( class, NULL, sizeof(class));
		memset( ident, NULL, sizeof(ident));

		strncpy( class, line+ 9, 6);
		strncpy( ident, line+19, strlen(line)-20 );
		
		if ( strstr(class, "HBA") == NULL ){
			sdidevs[scg][tgt][lun].valid = 1;
		}
		else {
			sdidevs[scg][tgt][lun].initiator = 1;
		}
					
		if ( strstr(ident, "(ide,") != NULL ){
			atapi = 1;
		}

		sdidevs[scg][tgt][lun].open  = 0;
		sdidevs[scg][tgt][lun].atapi = atapi;
		
		sdidevs[scg][tgt][lun].hba = hba;
		sdidevs[scg][tgt][lun].bus = bus;
		sdidevs[scg][tgt][lun].tgt = tgt;
		sdidevs[scg][tgt][lun].lun = lun;

		strcpy(sdidevs[scg][tgt][lun].type, class);
		strcpy(sdidevs[scg][tgt][lun].vend, ident);

		sprintf(sdidevs[scg][tgt][lun].devn, DEV_NAME, 
		        scg, tgt, lun);
			
		minor = SDI_MINOR(hba, tgt, lun, bus);
		node  = makedevice(major, minor);	
			
		sdidevs[scg][tgt][lun].major = major;
		sdidevs[scg][tgt][lun].minor = minor;
		sdidevs[scg][tgt][lun].node  = node;
		
		if (scgp->debug) {

		printf("h = %d; b = %d, s = %d, t = %d, l = %d, a = %d, ma = %d, mi = %2d, dev = %s, id = %s\n", 
		        hba, bus, scg, tgt, lun, 
			sdidevs[scg][tgt][lun].atapi, 
			sdidevs[scg][tgt][lun].major, 
			sdidevs[scg][tgt][lun].minor, 
			sdidevs[scg][tgt][lun].devn,
			sdidevs[scg][tgt][lun].vend );
		}			
			

        }
	
        if (pclose(pdiconfig) == -1) {
                perror("pclose error\n");
        }


	/* create all temporary device nodes */
	
	for (s = 0; s < MAX_SCG; s++) {
		for (t = 0; t < MAX_TGT; t++) {
			for (l = 0; l < MAX_LUN ; l++) {
			
			  if ( sdidevs[s][t][l].valid == 0) {
			  	sdidevs[s][t][l].fd = -1;
			  	continue;
			  }

			  /* Make pass-through interface device node */
			
			  sprintf(devname, "%s/%s", DEV_DIR, sdidevs[s][t][l].devn);
			
			  ptdev = sdidevs[s][t][l].node;

			  if (mknod(devname, S_IFCHR | 0700, ptdev) < 0) {
				if (errno == EEXIST) {
					unlink(devname);

					if (mknod(devname, S_IFCHR | 0700, ptdev) < 0) {
						printf("cdrecord: Cannot mknod %s: errno = %d\n",
						devname, errno);
						return (-1);
					}
				}
				else {
					printf("cdrecord: Cannot mknod %s: errno = %d\n",
					devname, errno);
					return (-1);
				}
			  }

			  /* Open pass-through device node */
			
			  if ((fd = open(devname, O_RDONLY)) < 0) {
				printf("cdrecord: Cannot open pass-through %s: errno = %d\n", devname, errno);
				return (-1);
			  }

			  sdidevs[s][t][l].fd   = fd;
			  sdidevs[s][t][l].open = 1;
  			  nopen++;
			  scglocal(scgp)->scgfiles[s][t][l] = (short) fd;

			  if (scgp->debug) {

				printf("s = %d, t = %d, l = %d, dev = %s, fd = %d\n", 
		    		    	s, t, l, 
					sdidevs[s][t][l].devn,
					sdidevs[s][t][l].fd );
			  }			


			}
		}
	}
	
	return(nopen);
}





EXPORT int
scsi_open(scgp, device, busno, tgt, tlun)
	SCSI	*scgp;
	char	*device;
	int	busno;
	int	tgt;
	int	tlun;
{
	int		c, b, t;
	char		devname[256];
	char		*cdr_dev;
	int		fd;
	int		ret;
	dev_t		ptdev;
	struct stat	stbuf;

	if (busno >= MAX_SCG || tgt >= MAX_TGT || tlun >= MAX_LUN) {
		errno = EINVAL;
		if (scgp->errstr)
			js_snprintf(scgp->errstr, SCSI_ERRSTR_SIZE,
				"Illegal value for busno, target or lun '%d,%d,%d'",
				busno, tgt, tlun);
		return (-1);
	}

	if (scgp->local == NULL) {
		scgp->local = malloc(sizeof(struct scg_local));
		if (scgp->local == NULL)
			return (0);

		for (c = 0; c < MAX_SCG; c++) {
			for (b = 0; b < MAX_TGT; b++) {
				for (t = 0; t < MAX_LUN ; t++)
					scglocal(scgp)->scgfiles[c][b][t] = (short)-1;
			}
		}
	}


	memset(sdidevs, 0, sizeof(sdidevs));	/* init tmp_structure */

	if (*device != '\0') {          /* still allow old dev usage */
		cdr_dev = device;
	} else {			/* this is the new stuff     */
		ret = unixware_init(scgp);
		return (ret);
	}
	
	if (busno < 0        || tgt <   0      || tlun < 0 || 
	    busno >= MAX_SCG || tgt >= MAX_TGT || tlun >= MAX_LUN) {	
	    printf("cdrecord: dev=%d,%d,%d invalid\n",	busno, tgt, tlun);
	    return -1;
	}

	/* Check for validity of device node */
	if (stat(cdr_dev, &stbuf) < 0) {
		return (-1);
	}
	if (!S_ISCHR(stbuf.st_mode)) {
		return (-1);
	}

	/* Open CD-Writer device */
	if ((fd = open(cdr_dev, O_RDONLY)) < 0) {
		printf("cdrecord: ");
		
		switch (errno) {
			
		case EIO: printf("Check media in %s !\n", cdr_dev);
			  break;
			
		default : perror(cdr_dev);

		}

		return (-1);
	}

	/* Get pass-through interface device number */
	if (ioctl(fd, B_GETDEV, &ptdev) < 0) {
		printf("cdrecord: get pass-through device B_GETDEV ioctl failed: errno = %d\n", errno);
		close(fd);
		return (-1);
	}

	close(fd);

	/* Make pass-through interface device node */
	sprintf(devname, "%s/cdrecord.%x", DEV_DIR, (int) ptdev);

	if (mknod(devname, S_IFCHR | 0700, ptdev) < 0) {
		if (errno == EEXIST) {
			unlink(devname);

			if (mknod(devname, S_IFCHR | 0700, ptdev) < 0) {
				printf("cdrecord: Cannot mknod %s: errno = %d\n",
					devname, errno);
				return (-1);
			}
		}
		else {
			printf("cdrecord: Cannot mknod %s: errno = %d\n",
				devname, errno);
			return (-1);
		}
	}

	/* Open pass-through device node */
	if ((fd = open(devname, O_RDONLY)) < 0) {
		printf("cdrecord: Cannot open pass-through %s: errno = %d\n", devname, errno);
		return (-1);
	}

	scglocal(scgp)->scgfiles[busno][tgt][tlun] = fd;
	return (1);
}

EXPORT int
scsi_close(scgp)
	SCSI	*scgp;
{
	register int	f;
	register int	b;
	register int	t;
	register int	l;

	if (scgp->local == NULL)
		return (-1);

	for (b=0; b < MAX_SCG; b++) {
		for (t=0; t < MAX_TGT; t++) {
			for (l=0; l < MAX_LUN ; l++) {

				f = scglocal(scgp)->scgfiles[b][t][l];
				if (f >= 0)
					close(f);

				sdidevs[b][t][l].fd    = -1;
				sdidevs[b][t][l].open  =  0;
				sdidevs[b][t][l].valid =  0;
				
				scglocal(scgp)->scgfiles[b][t][l] = (short)-1;
			}
		}
	}
	return (0);
}

LOCAL long
scsi_maxdma(scgp)
	SCSI	*scgp;
{
	return (MAX_DMA);
}


EXPORT void *
scsi_getbuf(scgp, amt)
	SCSI	*scgp;
	long	amt;
{
	if (amt <= 0 || amt > scsi_maxdma(scgp))
		return ((void *)0);
	if (scgp->debug)
		printf("scsi_getbuf: %ld bytes\n", amt);

	scgp->bufbase = (void *) valloc((size_t)(amt));

	return (scgp->bufbase);
}

EXPORT void
scsi_freebuf(scgp)
	SCSI	*scgp;
{
	if (scgp->bufbase)
		free(scgp->bufbase);
	scgp->bufbase = NULL;
}

EXPORT
BOOL scsi_havebus(scgp, busno)
	SCSI	*scgp;
	int	busno;
{
	register int	t;
	register int	l;

	if (busno < 0 || busno >= MAX_SCG)
		return (FALSE);

	if (scgp->local == NULL)
		return (FALSE);

	for (t=0; t < MAX_TGT; t++) {
		for (l=0; l < MAX_LUN ; l++)
			if (scglocal(scgp)->scgfiles[busno][t][l] >= 0)
				return (TRUE);
	}
	return (FALSE);
}

EXPORT
int scsi_fileno(scgp, busno, tgt, tlun)
	SCSI	*scgp;
	int	busno;
	int	tgt;
	int	tlun;
{
	if (busno < 0 || busno >= MAX_SCG ||
	    tgt   < 0 || tgt   >= MAX_TGT ||
	    tlun  < 0 || tlun  >= MAX_LUN)
		return (-1);

	if (scgp->local == NULL)
		return (-1);

	return ((int)scglocal(scgp)->scgfiles[busno][tgt][tlun]);
}

EXPORT int
scsi_initiator_id(scgp)
	SCSI	*scgp;
{
	register int	t;
	register int	l;
	register int	busno;
	
	busno = scgp->scsibus;

	if (busno < 0 || busno >= MAX_SCG)
		return (FALSE);

	for (t=0; t < MAX_TGT; t++) {
		for (l=0; l < MAX_LUN ; l++)
			if (sdidevs[busno][t][l].initiator == 1){
				if (scgp->debug)
					printf("scsi_initiator_id: id = %d\n", t);
				return (t);
			}
	}

	return (-1);
}

EXPORT
int scsi_isatapi(scgp)
	SCSI	*scgp;
{
	/* if the new address method is used we know if this is ATAPI*/
	
	return (sdidevs[scgp->scsibus][scgp->target][scgp->lun].atapi);
}

EXPORT
int scsireset(scgp)
	SCSI	*scgp;
{
	return(-1);		
}

LOCAL int
do_scsi_cmd(scgp, fd, sp)
	SCSI		*scgp;
	int		fd;
	struct scg_cmd	*sp;
{
	int			ret;
	int			i;
	struct sb		scsi_cmd;
	struct scb		*scbp;

	memset(&scsi_cmd,  0, sizeof(scsi_cmd));

	scsi_cmd.sb_type = ISCB_TYPE;
	scbp = &scsi_cmd.SCB;

	scbp->sc_cmdpt = (caddr_t) sp->cdb.cmd_cdb;
	scbp->sc_cmdsz = sp->cdb_len;

	scbp->sc_datapt = sp->addr;
	scbp->sc_datasz = sp->size;

	if (!(sp->flags & SCG_RECV_DATA) && (sp->size > 0))
		scbp->sc_mode = SCB_WRITE;
	else
		scbp->sc_mode = SCB_READ;

	scbp->sc_time = sp->timeout;

	errno = 0;
	for (;;) {
		if ((ret = ioctl(fd, SDI_SEND, &scsi_cmd)) < 0) {
			if (errno == EAGAIN){
				sleep(1);
				continue;
			}
			sp->ux_errno = errno;
			if (errno == 0)
				sp->ux_errno = EIO;
			sp->error = SCG_RETRYABLE;

			return (ret);
		}
		break;
	}

	memset(&sp->u_scb.Scb, 0, sizeof(sp->u_scb.Scb));
	sp->u_scb.cmd_scb[0] = scbp->sc_status;
	sp->resid = scbp->sc_resid;
	sp->ux_errno = errno;

	return 0;
}


LOCAL int
do_scsi_sense(scgp, fd, sp)
	SCSI		*scgp;
	int		fd;
	struct scg_cmd	*sp;
{
	int		ret;
	struct scg_cmd	s_cmd;

	if (sp->sense_len > SCG_MAX_SENSE)
		sp->sense_len = SCG_MAX_SENSE;

	memset((caddr_t)&s_cmd, 0, sizeof(s_cmd));
	
	s_cmd.addr      = (caddr_t) sp->u_sense.cmd_sense;
	s_cmd.size      = sp->sense_len;
	s_cmd.flags     = SCG_RECV_DATA|SCG_DISRE_ENA;
	s_cmd.cdb_len   = SC_G0_CDBLEN;
	s_cmd.sense_len = CCS_SENSE_LEN;
	s_cmd.target    = scgp->target;
	
	s_cmd.cdb.g0_cdb.cmd   = SC_REQUEST_SENSE;
	s_cmd.cdb.g0_cdb.lun   = sp->cdb.g0_cdb.lun;
	s_cmd.cdb.g0_cdb.count = sp->sense_len;

	ret = do_scsi_cmd(scgp, fd, &s_cmd);

	if (ret < 0)
		return (ret);
	
	sp->sense_count = sp->sense_len - s_cmd.resid;
	return (ret);
}

LOCAL int
scsi_send(scgp, fd, sp)
	SCSI		*scgp;
	int		fd;
	struct scg_cmd	*sp;
{
	int	ret;

	if ( fd < 0 ) {
		sp->error = SCG_FATAL;
		return (0);
	}
	else {
	
		ret = do_scsi_cmd(scgp, fd, sp);

		if (ret < 0)
			return (ret);

		if (sp->u_scb.cmd_scb[0] & S_CKCON)
			ret = do_scsi_sense(scgp, fd, sp);

		return (ret);
	}
}

#define	sense	u_sense.Sense
#undef	SC_PARITY
#define	SC_PARITY	0x09	
#define	scb		u_scb.Scb
